' FM1216-V2.04.BAS    fuer FM1216 Tuner und I2C LCD
' Autor: Heinrich Stummer, A-1180 Wien.  2013-2016
'
' Erstellt mit  BASCOM 2.0.7.8.  (kommerzielle Version)
'
' Retro Abstimmung via Poti auf Portb.2    (Retro weil Manuell per Drehknopf)  oder
' Sendersuchlauf per  PinB.2  wenn bei PowerOn  ADC Eingang auf GND gebrckt wurde
'
'FM1216 M3 tuner  FM 87.5 to 108 MHz stereo
'Pin 3 & 13     +5V
'Pin 4 SCL
'Pin 5 SDA
'Pin 6          Gnd. (I2C Addresse)
'Pin 9  FM radio Left Channel
'Pin 10 FM radio Right Channel
'case           GND
'PIN 13


$regfile = "attiny45.dat"
$crystal = 1000000
$hwstack = 40
$swstack = 16
$framesize = 32
$lib "Lcd_i2c.lib"           ' von BASCOM MCS runterladen,  ersetzt die Standard LCD Library

'ATTINY45
'------------------------------------------------
'RST +5V Vcc              ( Pin 1 )
'Portb.3 = stereo/mono    ( Pin 2 )
'Portb.4 = Tuning 0-5V    ( Pin 3 )
'Portb.0 = SCL            ( Pin 5 )
'Portb.1 = SDA            ( Pin 6 )
'Ground                   ( Pin 4 )
'Portb.2 = muting on/off  ( Pin 7 )   oder  Sendersuchlauf  increment
'+5V Vcc                  ( Pin 8 )


'------------------------------------------------
'deklarationen
'------------------------------------------------

Const Pcf8574_lcd = &H40          'I2C Adr. LCD  &H40
Const MyTuner = &HC0             ' I2C Adr. Tuner
Const MyZf = &H86                ' I2C Adr  ZF Teil

Dim Lcdfrq As Single
Dim _lcd_e As Byte
_lcd_e = 64                                                ' LCD use 4-Bit Mode

Const Autor = "Heinrich Stummer"

Dim sendersuch as Integer

Dim DB1 as Byte                 ' Tuner  lt Datenblatt
Dim DB2 as Byte
Dim CB as Byte
Dim BB as Byte
Dim AB as Byte
Dim Tstat as byte               ' TunerStatus

Dim BD as Byte                   ' ZF lt. Datenblatt       Bdata, Cdata, Edata
Dim CD as Byte
Dim ED as Byte
DIm ZfStat as byte                ' ZF STatus

Dim Poti As Word                                      ' TUN  1964-2374  => 87.5 - 108Mhz
Dim Tun as word
Dim oldTun as word
Dim N as single
Dim isTuned as integer           ' bei AFC "="  wird bis 60 hochgezhlt, dann nur Senderwechsel per TAste
Const FixTune = 60                ' loops bis fix erreicht ist , Sender wird im Eprom gespeichert
dim k as integer
Dim afc as string *1
Dim stind as string *6
Dim Speicher as Eram Word


declare sub goTuner
declare sub goZf
declare sub SetStereo
declare sub SetMono
declare sub Muting
declare sub NoMuting
declare sub PotiTune
declare sub tune
declare sub Freqlcd
declare sub getstate
declare sub afcstat
declare sub stereoInd
declare sub ScanTune
declare sub MyTaste

'-----------------------------------------

Config Scl = Portb.0
Config Sda = Portb.1
Config I2cdelay = 15

Config Portb.3 = Input                                      'stereo/mode
Config Portb.2 = Input                                      'Sendersuchlauf  INCR  / oder NoMuting  bei Poti
Portb = &B00001100                                           'Pullups

I2cinit
Waitms 100


Cls
Locate 1 , 1
Lcd "FM1216 V-2.04"
Locate 2 , 1
Lcd "UKW Radio"
waitms 300
cls                '  absichtlich kurz  , soll ja nicht stren, nur zur identifikation der Software  Version

Config Adc = Single , Prescaler = Auto
Start Adc

waitms 100

Poti  = GetADC(2)

If Poti = 0 Then sendersuch = 1 else sendersuch = 0   ' Scanmodus wenn Jumper auf GND
' 0 ist sendersuche  niedrigste F 87.5  ist bei 6  damit ist eine eingestellte 87.5 nie der Scanmodus !
' Bei 10K Poti ist an der Seite zu GND ein 100R Wid zu legen. Damit wird Sendersuche nur mit einer
' Brcke zu GND erkannt.


 DB1 =  &H1F              ' hohe frequenz TV Mode lt. Datenblatt    Nur fr INIT
 DB2 =  &HE2
 CB =   &H86
 BB =   &H44
 AB =   &HA0

 gotuner                  ' init Tuner

                          ' FM Mode einstellen   lt. Datenblatt
 DB1 =  &H08              ' High byte
 DB2 =  &H84              ' low byte
 CB =   &H88              ' &B10001000       'RSA u. RSB = 0 f. 50khz step    T0=1 for FM lt. Datenblatt

                          ' byte ATC = 0            'recommended for FM
 AB =   &H30              ' &B00110000       (109 uV)  recommended for FM     Bits AL0 AL1 Al2

 CD =   &HD0              ' &B11010000
 ED =   &H77              ' &B01110111

 setStereo
 Muting
 isTuned = 0

 If Sendersuch = 1 AND Speicher < 2375 Then
    Tun = Speicher - 2           ' absichtlich um 100khz verstimmen, fngt dann automatisch
    Tune
    waitms 200
 else
    PotiTune
 end If

                  '
Do

   If Pinb.3 = 0 Then SetMono else SetStereo    ' jumper Mono abfragen

   If Sendersuch = 0 Then                       ' Abfrage Potentiometer  Abstimmung oder Sendersuche
        Potitune

        If PinB.2 = 0 Then                      ' fr Mono und muting kein Debounce notwendig
              nomuting
        else
              muting
        end if

   else
        debounce PinB.2 ,0, MyTaste , Sub     ' Tastendruck startet  Sendersuche   ' hier absichtlich mit debounce
                                                ' prellen der Taste zu verhindern.
        If afc <> "=" Then Scantune            ' Sendersuche
   end IF


                         '
   If Tun <> Oldtun Then Tune               ' Nur ABstimmen wenn nderung

   getstate
   afcstat
   stereoind

   locate 2,1                               ' Stati am LCD anzeigen
   lcd afc
   lcd "  "
   lcd stind
   lcd "  "

   If Sendersuch = 1 Then                 ' nur bei Sendersuche
     if afc = "=" Then
       if istuned < FixTune then  incr istuned     ' > Fixtune ist fix abgestimmt im sendersuchlauf
     else
       istuned = 0
     end If
   else
      istuned = 0     ' bei Handabstimmung immer 0
   end If

Loop


End       '##################### end ########################


sub goTuner
   I2Cstart
    I2cwbyte MyTuner
    I2cwbyte DB1
    I2cwbyte DB2
    I2cwbyte CB
    I2cwbyte BB
    I2cwbyte AB
   I2CStop
end sub

sub goZf
   I2Cstart
    I2cwbyte MyZf
    I2cwbyte &H00                ' Subaddress Byte immer 00
    I2cwbyte BD
    I2cwbyte CD
    I2cwbyte ED
   I2CStop
end sub

function afcstat                        ' check AFC STatus
dim af as byte
dim fmif as byte
If istuned < FixTune Then
     af = zfstat AND   &B00011110    ' bits AFC1,2,3,4
     fmif = zfstat AND &B00100000    ' FMIFl    = 32      ' status ZF
     shift af, right
     afc = "x"                           ' ZF daneben
     if fmif = 32 Then
       If af = 13 Then afc = "="         ' +62.5khz         AFC Fenster lt. Datenblatt !
       If af = 14 Then afc = "="         ' +37.5kHz
       if af = 15 Then afc = "="         ' +12.5kHz
       If af = 0 Then afc = "="          ' -12,5kHz
       if af = 1 Then afc = "="          ' -37.5kHz
       if af = 2 Then afc = "="          ' -62.5kHz
     else
       afc = "."                         ' no zf          ' lt FMIF1
     end if
end If
end function


sub stereoInd                          ' stereoindicator
dim sti as byte
     sti = Tstat AND &B00000111   ' bits A2=1 A1=A0=0   4 ist stereao sonst mono
     if istuned < FixTune  Then
       if sti = 4 Then stind   = "stereo" else stind = "mono  "
     else
       if sti = 4 Then stind   = "Stereo" else stind = "Mono  "      ' if fixtund im Sendersuchlauf
       if Tun <> Speicher Then
                  Speicher = tun                       ' Bei Senersuchlauf abspeichern
                  stind = stind + " M"                 ' kurz zeigen dass gespeichert wird

       end if
     end If
     if afc = "." Then stind = "  .   "
end sub


sub getstate                     ' Statusbyte Tuner und ZF lesen    nach tstat und zfstat
    I2cstart
    I2cwbyte MyTuner +1
    I2crbyte tstat, ack
    I2cstop
    waitms 1
    I2cstart
    I2cwbyte myzf + 1
    I2crbyte zfstat, ack
    I2cstop
end Sub


Sub SetStereo                    'Stereo einschalten
     BB = &H19
     goTuner
end sub

Sub SetMono                      'Mono einschalten
     BB = &H59
     goTuner
end Sub
                                 ' das bit1 = 0 macht frchterlichen Krach...  daher Auto Mute Bit 1 immer 1
Sub Muting                       ' muting         ' Low sense   (AUto Mute FMbit bit 1)
     BD = &H0E
     gozf
end SUb

Sub NoMuting                     ' kein muting    ' high sense   (AUto Mute FMbit bit 1)
     BD = &H4E
     gozf
end Sub

Sub PotiTune                      ' abstimmmung per Poti
  Poti  = GetADC(2)               ' ADC 0-1024  PB4
  N = Poti / 2.45                 ' Stufung anpassen   ADC zu Tuning 1024 zu 410 steps (410 Kanle im FM Band)
                                  ' hier auf 417 Steps anpassen.  weil 0 ist fr scanmodus erkennung
  N = int(n)
  Tun = 1958 + N                  ' 1958  ---> fr Moduserkennung darber die FM Kanle
  If Tun > 2374 Then Tun = 2374
  If Tun < 1964 Then Tun = 1964   ' F Grenzen checken
end sub

Sub ScanTune                       ' Abstimung per Scan   INCR
  If Tun < 1964 Then Tun = 1964
  if afc <> "=" Then incr Tun
  If Tun > 2374 Then Tun = 1964    ' wrap arround
end sub

Sub Mytaste                         ' Taste fr Scan erkannt
   incr Tun
   Incr Tun                         ' um 100KHz verstimmen und afc auf nicht abgestimmt setzen
   afc = " "
   istuned = 0
end sub

sub Tune                           ' Die F am Tuner einstellen und anzeigen
  DB1=high(tun)
  DB2=low(tun)
  gotuner
  Freqlcd
  OldTun = Tun
end SUb

Sub Freqlcd                      ' Show F on display
 Lcdfrq = Tun * 0.05
 Lcdfrq = Lcdfrq - 10.7
 Locate 1 , 1
 If Lcdfrq < 100 Then
  Lcd " "
  Locate 1 , 2
 End If

 Lcd Fusing(lcdfrq , "###.##") + " MHz"
End Sub